package edu.upvehu.gb.tap.tipografias;

import java.util.Map;
import java.util.TreeMap;

/**
 * Proxy para una tipografía particularizado por carácter.
 * Permite establecer el patrón gráfico como Singleton y que su generación sea "lazy".
 * También son singletons los diferentes Grapheme por caracter y tipografía. No por tamaño.
 *(es dudoso el planteamiento para un caso real, pero se trata de un ejemplo)
 * 
 * @author Clase
 */
public class DefaultGrapheme implements Grapheme{

private final static int DEFAULT_SIZE=5;

private int size;
private char character;
private Typography typography;
private String[] thePattern=null;
static Map<String,Grapheme> instances=new TreeMap<>();

    DefaultGrapheme(char c, Typography t) {
       this(c,DEFAULT_SIZE,t);
    }
    private DefaultGrapheme(char c, int n, Typography t) {
       character=c;
       size=n;
       typography=t;
    }
    
    static Grapheme getInstance(char c, Typography aThis) {
        Grapheme g=instances.get(c+aThis.toString());
        if (g==null)
            instances.put(c+aThis.toString(), g=new DefaultGrapheme(c,aThis));
        g.setSize(DEFAULT_SIZE);
        return g;
        }

    @Override public void setSize(int size) {
        if (this.size==size) return;
        this.size=size;
        thePattern=null;
    }
    
    @Override public int getSize() {return size;}

    @Override
    public String[] createPattern() {
        if (thePattern!=null) return thePattern;
        if (typography instanceof Typography1) return thePattern=((Typography1)typography).createPattern(character, size);
        if (typography instanceof Typography2) return thePattern=((Typography2)typography).createPattern(character, size);
        return null;
    }
    
}
